From 9f3d7ad037b48511212781ba9864c77ed3218778 Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Fri, 9 Jul 2021 23:21:47 +0000
Subject: [PATCH] [arm64] port luma_hpp

luma_hpp[  4x4]		6.62x 	 70.31    	 465.57
luma_hpp[  8x8]		13.73x 	 134.46   	 1845.80
luma_hpp[16x16]		15.15x 	 481.85   	 7302.42
luma_hpp[32x32]		15.92x 	 1857.16  	 29568.30
luma_hpp[64x64]		16.56x 	 7106.80  	 117723.80
luma_hpp[  8x4]		13.22x 	 70.13    	 927.30
luma_hpp[  4x8]		6.85x 	 136.53   	 935.87
luma_hpp[ 16x8]		14.78x 	 246.06   	 3635.85
luma_hpp[ 8x16]		14.10x 	 262.56   	 3701.81
luma_hpp[32x16]		16.06x 	 917.04   	 14729.45
luma_hpp[16x32]		15.29x 	 961.23   	 14694.73
luma_hpp[64x32]		16.40x 	 3590.07  	 58883.16
luma_hpp[32x64]		16.02x 	 3691.95  	 59153.97
luma_hpp[16x12]		15.14x 	 363.18   	 5496.85
luma_hpp[12x16]		11.45x 	 478.71   	 5482.72
luma_hpp[ 16x4]		14.42x 	 125.28   	 1806.93
luma_hpp[ 4x16]		6.92x 	 269.02   	 1862.02
luma_hpp[32x24]		15.94x 	 1392.68  	 22205.81
luma_hpp[24x32]		16.06x 	 1389.21  	 22306.88
luma_hpp[ 32x8]		15.94x 	 462.55   	 7370.89
luma_hpp[ 8x32]		14.21x 	 519.89   	 7385.71
luma_hpp[64x48]		16.12x 	 5465.88  	 88092.30
luma_hpp[48x64]		16.13x 	 5473.27  	 88301.40
luma_hpp[64x16]		16.12x 	 1825.85  	 29437.21
luma_hpp[16x64]		15.48x 	 1891.90  	 29293.72
---
 source/common/aarch64/asm-primitives.cpp |  27 +++++
 source/common/aarch64/ipfilter8.S        | 147 ++++++++++++++++++++++-
 source/common/aarch64/ipfilter8.h        |  26 ++++
 source/common/arm/ipfilter8.S            |   1 -
 4 files changed, 195 insertions(+), 6 deletions(-)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 60ca1e4..f20f940 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -444,6 +444,33 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.chroma[X265_CSP_I444].pu[LUMA_64x64].filter_vsp = PFX(interp_4tap_vert_sp_64x64_neon);
         p.chroma[X265_CSP_I444].pu[LUMA_24x32].filter_vsp = PFX(interp_4tap_vert_sp_24x32_neon);
         p.chroma[X265_CSP_I444].pu[LUMA_48x64].filter_vsp = PFX(interp_4tap_vert_sp_48x64_neon);
+
+        // luma_hpp
+        p.pu[LUMA_4x4].luma_hpp   = PFX(interp_horiz_pp_4x4_neon);
+        p.pu[LUMA_4x8].luma_hpp   = PFX(interp_horiz_pp_4x8_neon);
+        p.pu[LUMA_4x16].luma_hpp  = PFX(interp_horiz_pp_4x16_neon);
+        p.pu[LUMA_8x4].luma_hpp   = PFX(interp_horiz_pp_8x4_neon);
+        p.pu[LUMA_8x8].luma_hpp   = PFX(interp_horiz_pp_8x8_neon);
+        p.pu[LUMA_8x16].luma_hpp  = PFX(interp_horiz_pp_8x16_neon);
+        p.pu[LUMA_8x32].luma_hpp  = PFX(interp_horiz_pp_8x32_neon);
+        p.pu[LUMA_12x16].luma_hpp = PFX(interp_horiz_pp_12x16_neon);
+        p.pu[LUMA_16x4].luma_hpp  = PFX(interp_horiz_pp_16x4_neon);
+        p.pu[LUMA_16x8].luma_hpp  = PFX(interp_horiz_pp_16x8_neon);
+        p.pu[LUMA_16x12].luma_hpp = PFX(interp_horiz_pp_16x12_neon);
+        p.pu[LUMA_16x16].luma_hpp = PFX(interp_horiz_pp_16x16_neon);
+        p.pu[LUMA_16x32].luma_hpp = PFX(interp_horiz_pp_16x32_neon);
+        p.pu[LUMA_16x64].luma_hpp = PFX(interp_horiz_pp_16x64_neon);
+        p.pu[LUMA_24x32].luma_hpp = PFX(interp_horiz_pp_24x32_neon);
+        p.pu[LUMA_32x8].luma_hpp  = PFX(interp_horiz_pp_32x8_neon);
+        p.pu[LUMA_32x16].luma_hpp = PFX(interp_horiz_pp_32x16_neon);
+        p.pu[LUMA_32x24].luma_hpp = PFX(interp_horiz_pp_32x24_neon);
+        p.pu[LUMA_32x32].luma_hpp = PFX(interp_horiz_pp_32x32_neon);
+        p.pu[LUMA_32x64].luma_hpp = PFX(interp_horiz_pp_32x64_neon);
+        p.pu[LUMA_48x64].luma_hpp = PFX(interp_horiz_pp_48x64_neon);
+        p.pu[LUMA_64x16].luma_hpp = PFX(interp_horiz_pp_64x16_neon);
+        p.pu[LUMA_64x32].luma_hpp = PFX(interp_horiz_pp_64x32_neon);
+        p.pu[LUMA_64x48].luma_hpp = PFX(interp_horiz_pp_64x48_neon);
+        p.pu[LUMA_64x64].luma_hpp = PFX(interp_horiz_pp_64x64_neon);
     }
 }
 } // namespace X265_NS
diff --git a/source/common/aarch64/ipfilter8.S b/source/common/aarch64/ipfilter8.S
index ecc4833..a2f72de 100644
--- a/source/common/aarch64/ipfilter8.S
+++ b/source/common/aarch64/ipfilter8.S
@@ -1847,6 +1847,145 @@ CHROMA_VSP 48 64
     ext             v3.8b, v3.8b, v7.8b, #7
 .endm
 
+.macro HPP_FILTER w h filterhpp
+    mov             w12, #32
+    dup             v30.4s, w12
+    mov             w6, #\h
+    sub             x3, x3, #\w
+    mov             w9, #\w
+    cmp             w9, #4
+    beq             4f
+    cmp             w9, #12
+    beq             12f
+    b               6f
+4:
+.loop4_hpp_\filterhpp\()_\w\()x\h:
+    mov             x11, x0
+    sub             x11, x11, #4
+    vextin8
+    \filterhpp
+    add             v17.4s, v17.4s, v30.4s
+    sqshrun         v0.4h, v17.4s, #6
+    add             v18.4s, v18.4s, v30.4s
+    sqshrun         v1.4h, v18.4s, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.s}[0], [x2], #4
+
+    sub             x6, x6, #1
+    add             x0, x0, x1
+    add             x2, x2, x3
+    cbnz            x6, .loop4_hpp_\filterhpp\()_\w\()x\h
+    b               5f
+12:
+.loop12_hpp_\filterhpp\()_\w\()x\h:
+    mov             x11, x0
+    sub             x11, x11, #4
+    vextin8
+    \filterhpp
+    add             v17.4s, v17.4s, v30.4s
+    sqshrun         v0.4h, v17.4s, #6
+    add             v18.4s, v18.4s, v30.4s
+    sqshrun         v1.4h, v18.4s, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.8b}, [x2], #8
+
+    sub             x11, x11, #8
+
+    vextin8
+    \filterhpp
+    add             v17.4s, v17.4s, v30.4s
+    sqshrun         v0.4h, v17.4s, #6
+    add             v18.4s, v18.4s, v30.4s
+    sqshrun         v1.4h, v18.4s, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.s}[0], [x2], #4
+    sub             x6, x6, #1
+    add             x0, x0, x1
+    add             x2, x2, x3
+    cbnz            x6, .loop12_hpp_\filterhpp\()_\w\()x\h
+    b               5f
+6:
+.loop2_hpp_\filterhpp\()_\w\()x\h:
+    mov             x7, #\w
+    lsr             x7, x7, #3
+    mov             x11, x0
+    sub             x11, x11, #4
+.loop3_hpp_\filterhpp\()_\w\()x\h:
+    vextin8
+    \filterhpp
+    add             v17.4s, v17.4s, v30.4s
+    sqshrun         v0.4h, v17.4s, #6
+    add             v18.4s, v18.4s, v30.4s
+    sqshrun         v1.4h, v18.4s, #6
+    trn1            v0.2d, v0.2d, v1.2d
+    sqxtun          v0.8b, v0.8h
+    st1             {v0.8b}, [x2], #8
+
+    sub             x7, x7, #1
+    sub             x11, x11, #8
+    cbnz            x7, .loop3_hpp_\filterhpp\()_\w\()x\h
+    sub             x6, x6, #1
+    add             x0, x0, x1
+    add             x2, x2, x3
+    cbnz            x6, .loop2_hpp_\filterhpp\()_\w\()x\h
+5:
+.endm
+
+// void interp_horiz_pp_c(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx)
+.macro LUMA_HPP w h
+function x265_interp_horiz_pp_\w\()x\h\()_neon
+    cmp             x4, #0
+    beq              0f
+    cmp             x4, #1
+    beq              1f
+    cmp             x4, #2
+    beq              2f
+    cmp             x4, #3
+    beq              3f
+0:
+    HPP_FILTER  \w \h qpel_filter_0_32b
+    ret
+1:
+    HPP_FILTER  \w \h qpel_filter_1_32b
+    ret
+2:
+    HPP_FILTER  \w \h qpel_filter_2_32b
+    ret
+3:
+    HPP_FILTER  \w \h qpel_filter_3_32b
+    ret
+endfunc
+.endm
+
+LUMA_HPP    4 4
+LUMA_HPP    4 8
+LUMA_HPP    4 16
+LUMA_HPP    8 4
+LUMA_HPP    8 8
+LUMA_HPP    8 16
+LUMA_HPP    8 32
+LUMA_HPP    12 16
+LUMA_HPP    16 4
+LUMA_HPP    16 8
+LUMA_HPP    16 12
+LUMA_HPP    16 16
+LUMA_HPP    16 32
+LUMA_HPP    16 64
+LUMA_HPP    24 32
+LUMA_HPP    32 8
+LUMA_HPP    32 16
+LUMA_HPP    32 24
+LUMA_HPP    32 32
+LUMA_HPP    32 64
+LUMA_HPP    48 64
+LUMA_HPP    64 16
+LUMA_HPP    64 32
+LUMA_HPP    64 48
+LUMA_HPP    64 64
+
 // void interp_horiz_ps_c(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt)
 .macro HPS_FILTER a b filterhps
     mov             w12, #8192
@@ -2035,17 +2174,15 @@ function x265_interp_8tap_horiz_ps_\w\()x\h\()_neon
     b.eq            3f
 0:
     HPS_FILTER  \w \h qpel_filter_0_32b
-    b               5f
+    ret
 1:
     HPS_FILTER  \w \h qpel_filter_1_32b
-    b               5f
+    ret
 2:
     HPS_FILTER  \w \h qpel_filter_2_32b
-    b               5f
+    ret
 3:
     HPS_FILTER  \w \h qpel_filter_3_32b
-    b               5f
-5:
     ret
 endfunc
 .endm
diff --git a/source/common/aarch64/ipfilter8.h b/source/common/aarch64/ipfilter8.h
index 8e68e3c..072ad0a 100644
--- a/source/common/aarch64/ipfilter8.h
+++ b/source/common/aarch64/ipfilter8.h
@@ -215,6 +215,32 @@ void x265_interp_4tap_vert_sp_64x32_neon(const int16_t* src, intptr_t srcStride,
 void x265_interp_4tap_vert_sp_64x64_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 void x265_interp_4tap_vert_sp_64x48_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 
+void x265_interp_horiz_pp_4x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_4x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_4x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_8x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_8x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_8x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_8x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_12x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_16x4_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_16x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_16x12_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_16x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_16x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_16x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_24x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_32x8_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_32x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_32x24_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_32x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_32x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_48x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_64x16_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_64x32_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_64x48_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_horiz_pp_64x64_neon(const pixel* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
+
 void x265_interp_8tap_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
diff --git a/source/common/arm/ipfilter8.S b/source/common/arm/ipfilter8.S
index 9309bda..b7c8578 100644
--- a/source/common/arm/ipfilter8.S
+++ b/source/common/arm/ipfilter8.S
@@ -2548,7 +2548,6 @@ loop4_hpp_\filterhpp\()_\w\()x\h:
     vqshrun.s32     d1, q10, #6
     vqmovn.u16      d0, q0
     vst1.u32        {d0[0]}, [r2]!
-    sub             r5, #8
     subs            r6, #1
     add             r0, r1
     add             r2, r3
-- 
2.25.1

